import utils
from utils import *



def LoadDicts():
	unigrams = dict()
	bigrams = dict()
	trigrams = dict()
	wordFile = open(DICT_NAME, 'r')
	for line in wordFile:
		line = line.lstrip('\n').rstrip('\n').lower()
		words = line.split(' ')
		if line != '':	
			if len(words) == 1:
				unigrams[line] = 1
			elif len(words) == 2:
				bigrams[line] = 1
			elif len(words) == 3:
				trigrams[line] = 1 
	wordFile.close()
	return unigrams, bigrams, trigrams


##output a metric describing how likely that the subject of the 
##given string is the same as the dictionary
def FindMatch(text):	
	
	unigrams, bigrams, trigrams = LoadDicts()	
	uniCount = biCount = triCount= 0	
	totalWords=0
	lineCount = 0 
	for line in text.split('\n'):
			words = line.split(' ')
			wnum = len(words)
			totalWords += wnum
			if  line.find('$') != -1:
				uniCount += 1
			if line != '' and line != '\n':
				lineCount += 1
			#traverse line and determine how many unigrams, bigrams, and trigrams exist
			for i in range(wnum):
				if words[i].lower() in unigrams:
					uniCount += 1
					##print words[i]
				if i+1<wnum and words[i].lower() + ' ' + words[i+1].lower() in bigrams:
					biCount += 1		
					##print words[i]	
				if i+2<wnum and words [i].lower() + ' ' + words[i+1].lower() + ' ' + words[i+2].lower() in trigrams:	
					triCount += 1
					##print words[i]
	
	if lineCount < 5:
		return 0	
	uniPerc = float(uniCount)/float( totalWords+.01)
	biPerc = float(biCount)/ (float(totalWords-1) + .01)
	triPerc = float(triCount)/(float(totalWords-2) +.01)
	return uniPerc+biPerc+triPerc
