from cv2 import cv
import tesseract
import sys
from Queue import PriorityQueue
from threading import Thread

frames = PriorityQueue()
done = 0

#break file into frames while placing them in global queue
def BreakIntoFrames(videofile):
	global frames
	global done
	
	api = tesseract.TessBaseAPI()
	api.Init(".","eng",tesseract.OEM_DEFAULT)
	api.SetPageSegMode(tesseract.PSM_AUTO)
	cap = cv.CaptureFromFile(videofile)
	
	numFrames = 0
	success = 1;
	text = ''
	while success:
		success = cv.GrabFrame(cap)
			
		if not success:
			break
		img = cv.RetrieveFrame(cap)
		threshold=140
		colour=255
		cv.Threshold(img,img, threshold,colour,cv.CV_THRESH_BINARY) 
		img_processed = cv.CreateImage((img.width * 2,img.height *2), img.depth, img.nChannels)
		cv.Resize(img, img_processed)
	
		#frames.put(cv.RetrieveFrame(cap))
		if numFrames == 0:
			print "ocring"
			cv.SaveImage('img.png',img_processed)
			tesseract.SetCvImage(img_processed,api)
			text += api.GetUTF8Text()
			text += '\n ---------------------------\n'
			conf=api.MeanTextConf()			
		numFrames += 1 
	
	done = 1
	print 'Frames Analysed:' + str(numFrames)
	f = open('output.txt', 'w')
	f.write(text)
	return

def CompareImages(image1, image2):
	
	return
"""
##grab frames from global queue and run them through ocr
def OCRFrames():
	global frames
	global done	
	
	numFrames = 0
	text = '';
	while not frames.empty() or not done:
		while not frames.empty():	
			img = frames.get()
			if numFrames > 471:
				tesseract.SetCvImage(img,api)
				text += api.GetUTF8Text()
				text += '\n ---------------------------\n'
				conf=api.MeanTextConf()			
			numFrames += 1
			
	
	print 'Frames Analysed:' + str(numFrames)
	f = open('output.txt', 'w')
	f.write(text)
	return

"""
if __name__ == '__main__':
	if len(sys.argv) != 2:
		print 'Provide Video File'
	else:
		filename = sys.argv[1]
		BreakIntoFrames(filename)
		"""
		getFrames = Thread(target = BreakIntoFrames, args = [filename])
		
		ocrFrames= Thread(target = OCRFrames)
		##getFrames.setDaemon(True)
		##ocrFrames.setDaemon(True)
		getFrames.start()
		ocrFrames.start()
	"""
