import os, errno
import sys
from random import randint
from math import ceil
#########################File names and locations#################################
DICT_NAME = 'fin_terms.dat'
SENS_FRAME_DIR ='./frames/'
PROCESS_DB  = 'Process'
JSON_FILE = 'data.json'


def mkdir_p(path):
    try:
        os.makedirs(path)
    except OSError as exc: 
        if exc.errno == errno.EEXIST:
            pass
        else: raise

###################Simple Image manipulation functions##################################
#convert image to greyscale
def rgb2gray(image):
	return ((image[:,:,0]+image[:,:,1]+image[:,:,2])/3)

#return a numeric difference between image1 and image2
def CompareImages(image1, image2):
	maxchangeframe = 1
	diff = abs(rgb2gray(image1) - rgb2gray(image2))
	if diff.sum() != 0:
		change = diff.sum()/(diff.size * maxchangeframe)
	else:
		change = 0
	return change

###################List Functions##################################################

##Randomly sample list
def GetRandomSubset(alist,prop):
	length = len(alist)
	subset = []
	for i in range(int(ceil(length*prop))):
		randIndex = randint(0,length-1)
		while alist[randIndex]  in  subset:
			randIndex = randint(0, length-1)
		subset.append(alist[randIndex])
	return subset

